emop_call(M, _P, Pos) :-
   var(M),
   throw(error(instanciation_error(emop_call / 3), Pos)).
%emop_call(_, P, Pos) :-
%   functor(P, F, N),
%   print(stderr, F / N - Pos),
%   nl(stderr),
%   fail.
emop_call('$module'(_Id, List, _), P, Pos) :-
   !,
   emop_call_multi(List, P, Pos).
emop_call(Atom, P, Pos) :-
   g_read(Atom, M),
   !,
   Cut = '$cut',
   emop_call_to(M, P, Pos, Cut).

emop_call_multi([M], P, Pos) :-
   !,
   !,
   Cut = '$cut',
   emop_call_to(M, P, Pos, Cut).
emop_call_multi(List, P, Pos) :-
   emop_call_filter(List, P, List0),
   !,
   (
      List0 = []
   ->
      functor(P, F, N),
      throw(error(unknown_predicate(F / N), Pos))
   ;
      !,
      Cut = '$cut',
      emop_call_list(List0, P, Pos, Cut)
   ).
emop_call_multi(Invalid, _P, _Pos) :-
   throw(invalid(Invalid)).
   
emop_call(M, P) :-
   emop_call(M, P, dummy).

emop_call_list([M | Tail], P, Pos, Cut) :-
   (
      emop_call_list(Tail, P, Pos, Cut)
   ;
      emop_call_to(M, P, Pos, Cut)
   ).

emop_call_filter([], _, []).
emop_call_filter([H | T], P, List) :-
   functor(H, M, _),
   atom_concat(M, '$has_predicate', A),
   functor(C, A, 1),
   setarg(1, C, P),
   (
      call(C)
   ->
      List = [H | Tail]
   ;
      List = Tail
   ),
   emop_call_filter(T, P, Tail).

portray('$module'(Id, List, Terms)) :-
   M = '$module'(Id, List, Terms),
   get_print_stream(S),
   catch(
      (
         emop_call('io.stream', of_kernel_out(S, Ms), 'portray'),
         emop_call(M, 'portray'(Ms), 'portray')
      ),
      _,
      format(S, '<module[~d]>', [Id])
   ).
